// Generated by gencpp from file ld_msgs/ld_object_list.msg
// DO NOT EDIT!


#ifndef LD_MSGS_MESSAGE_LD_OBJECT_LIST_H
#define LD_MSGS_MESSAGE_LD_OBJECT_LIST_H


#include <string>
#include <vector>
#include <map>

#include <ros/types.h>
#include <ros/serialization.h>
#include <ros/builtin_message_traits.h>
#include <ros/message_operations.h>

#include <std_msgs/Header.h>
#include <ld_msgs/ld_object.h>

namespace ld_msgs
{
template <class ContainerAllocator>
struct ld_object_list_
{
  typedef ld_object_list_<ContainerAllocator> Type;

  ld_object_list_()
    : header()
    , frame_number(0)
    , objects()  {
    }
  ld_object_list_(const ContainerAllocator& _alloc)
    : header(_alloc)
    , frame_number(0)
    , objects(_alloc)  {
  (void)_alloc;
    }



   typedef  ::std_msgs::Header_<ContainerAllocator>  _header_type;
  _header_type header;

   typedef uint32_t _frame_number_type;
  _frame_number_type frame_number;

   typedef std::vector< ::ld_msgs::ld_object_<ContainerAllocator> , typename ContainerAllocator::template rebind< ::ld_msgs::ld_object_<ContainerAllocator> >::other >  _objects_type;
  _objects_type objects;





  typedef boost::shared_ptr< ::ld_msgs::ld_object_list_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::ld_msgs::ld_object_list_<ContainerAllocator> const> ConstPtr;

}; // struct ld_object_list_

typedef ::ld_msgs::ld_object_list_<std::allocator<void> > ld_object_list;

typedef boost::shared_ptr< ::ld_msgs::ld_object_list > ld_object_listPtr;
typedef boost::shared_ptr< ::ld_msgs::ld_object_list const> ld_object_listConstPtr;

// constants requiring out of line definition



template<typename ContainerAllocator>
std::ostream& operator<<(std::ostream& s, const ::ld_msgs::ld_object_list_<ContainerAllocator> & v)
{
ros::message_operations::Printer< ::ld_msgs::ld_object_list_<ContainerAllocator> >::stream(s, "", v);
return s;
}

} // namespace ld_msgs

namespace ros
{
namespace message_traits
{



// BOOLTRAITS {'IsFixedSize': False, 'IsMessage': True, 'HasHeader': True}
// {'sensor_msgs': ['/opt/ros/kinetic/share/sensor_msgs/cmake/../msg'], 'std_msgs': ['/opt/ros/kinetic/share/std_msgs/cmake/../msg'], 'geometry_msgs': ['/opt/ros/kinetic/share/geometry_msgs/cmake/../msg'], 'ld_msgs': ['/home/shawn/Documents/ROS_ws/src/HighResolutionLidarAlgorithm/src/ld_msgs/msg']}

// !!!!!!!!!!! ['__class__', '__delattr__', '__dict__', '__doc__', '__eq__', '__format__', '__getattribute__', '__hash__', '__init__', '__module__', '__ne__', '__new__', '__reduce__', '__reduce_ex__', '__repr__', '__setattr__', '__sizeof__', '__str__', '__subclasshook__', '__weakref__', '_parsed_fields', 'constants', 'fields', 'full_name', 'has_header', 'header_present', 'names', 'package', 'parsed_fields', 'short_name', 'text', 'types']




template <class ContainerAllocator>
struct IsFixedSize< ::ld_msgs::ld_object_list_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct IsFixedSize< ::ld_msgs::ld_object_list_<ContainerAllocator> const>
  : FalseType
  { };

template <class ContainerAllocator>
struct IsMessage< ::ld_msgs::ld_object_list_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::ld_msgs::ld_object_list_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::ld_msgs::ld_object_list_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::ld_msgs::ld_object_list_<ContainerAllocator> const>
  : TrueType
  { };


template<class ContainerAllocator>
struct MD5Sum< ::ld_msgs::ld_object_list_<ContainerAllocator> >
{
  static const char* value()
  {
    return "61e15ca6fbba34774d961f7a5f1faf4f";
  }

  static const char* value(const ::ld_msgs::ld_object_list_<ContainerAllocator>&) { return value(); }
  static const uint64_t static_value1 = 0x61e15ca6fbba3477ULL;
  static const uint64_t static_value2 = 0x4d961f7a5f1faf4fULL;
};

template<class ContainerAllocator>
struct DataType< ::ld_msgs::ld_object_list_<ContainerAllocator> >
{
  static const char* value()
  {
    return "ld_msgs/ld_object_list";
  }

  static const char* value(const ::ld_msgs::ld_object_list_<ContainerAllocator>&) { return value(); }
};

template<class ContainerAllocator>
struct Definition< ::ld_msgs::ld_object_list_<ContainerAllocator> >
{
  static const char* value()
  {
    return "std_msgs/Header header\n\
uint32          frame_number #@shawn\n\
ld_object[] objects\n\
           \n\
\n\
================================================================================\n\
MSG: std_msgs/Header\n\
# Standard metadata for higher-level stamped data types.\n\
# This is generally used to communicate timestamped data \n\
# in a particular coordinate frame.\n\
# \n\
# sequence ID: consecutively increasing ID \n\
uint32 seq\n\
#Two-integer timestamp that is expressed as:\n\
# * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')\n\
# * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')\n\
# time-handling sugar is provided by the client library\n\
time stamp\n\
#Frame this data is associated with\n\
# 0: no frame\n\
# 1: global frame\n\
string frame_id\n\
\n\
================================================================================\n\
MSG: ld_msgs/ld_object\n\
std_msgs/Header                 header\n\
################ object character\n\
uint32                          id  # ukf_id\n\
string                          object_status # dynamic or static status of the object\n\
float32                         confidence   # Overall detected confidence of the object\n\
std_msgs/ColorRGBA              color   # Define this object specific color\n\
\n\
################ 3D BB\n\
bool                            pose_reliable\n\
uint8                           box_label  # Null = 0, on_road = 1, on_edge = 2, edge_left = 3, edge_right = 4\n\
\n\
geometry_msgs/Pose              pose\n\
geometry_msgs/Point             pose_var \n\
\n\
geometry_msgs/Pose              jsk_pose # pose from accociated bbox\n\
\n\
float32                         yaw # yaw angel in radian\n\
float32                         yaw_var # cov of yaw angel in radian\n\
\n\
geometry_msgs/Vector3           dimensions\n\
geometry_msgs/Point             dimensions_var  \n\
\n\
geometry_msgs/Twist             velocity\n\
geometry_msgs/Twist             velocity_var\n\
\n\
geometry_msgs/Twist             acceleration\n\
geometry_msgs/Twist             acceleration_var\n\
\n\
#################  class label info\n\
string                          class_label_true # ground truth labels\n\
string                          class_label_pred # predicted class labels\n\
bool                            target_added # manually added target by labeling tool\n\
bool                            target_deleted # manually deleted target by labeling tool\n\
\n\
############### Behavior State of the Detected Object\n\
uint8                           behavior_state # FORWARD_STATE = 0, STOPPING_STATE = 1, BRANCH_LEFT_STATE = 2, BRANCH_RIGHT_STATE = 3, YIELDING_STATE = 4, ACCELERATING_STATE = 5, SLOWDOWN_STATE = 6\n\
\n\
\n\
\n\
================================================================================\n\
MSG: std_msgs/ColorRGBA\n\
float32 r\n\
float32 g\n\
float32 b\n\
float32 a\n\
\n\
================================================================================\n\
MSG: geometry_msgs/Pose\n\
# A representation of pose in free space, composed of position and orientation. \n\
Point position\n\
Quaternion orientation\n\
\n\
================================================================================\n\
MSG: geometry_msgs/Point\n\
# This contains the position of a point in free space\n\
float64 x\n\
float64 y\n\
float64 z\n\
\n\
================================================================================\n\
MSG: geometry_msgs/Quaternion\n\
# This represents an orientation in free space in quaternion form.\n\
\n\
float64 x\n\
float64 y\n\
float64 z\n\
float64 w\n\
\n\
================================================================================\n\
MSG: geometry_msgs/Vector3\n\
# This represents a vector in free space. \n\
# It is only meant to represent a direction. Therefore, it does not\n\
# make sense to apply a translation to it (e.g., when applying a \n\
# generic rigid transformation to a Vector3, tf2 will only apply the\n\
# rotation). If you want your data to be translatable too, use the\n\
# geometry_msgs/Point message instead.\n\
\n\
float64 x\n\
float64 y\n\
float64 z\n\
================================================================================\n\
MSG: geometry_msgs/Twist\n\
# This expresses velocity in free space broken into its linear and angular parts.\n\
Vector3  linear\n\
Vector3  angular\n\
";
  }

  static const char* value(const ::ld_msgs::ld_object_list_<ContainerAllocator>&) { return value(); }
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

  template<class ContainerAllocator> struct Serializer< ::ld_msgs::ld_object_list_<ContainerAllocator> >
  {
    template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
    {
      stream.next(m.header);
      stream.next(m.frame_number);
      stream.next(m.objects);
    }

    ROS_DECLARE_ALLINONE_SERIALIZER
  }; // struct ld_object_list_

} // namespace serialization
} // namespace ros

namespace ros
{
namespace message_operations
{

template<class ContainerAllocator>
struct Printer< ::ld_msgs::ld_object_list_<ContainerAllocator> >
{
  template<typename Stream> static void stream(Stream& s, const std::string& indent, const ::ld_msgs::ld_object_list_<ContainerAllocator>& v)
  {
    s << indent << "header: ";
    s << std::endl;
    Printer< ::std_msgs::Header_<ContainerAllocator> >::stream(s, indent + "  ", v.header);
    s << indent << "frame_number: ";
    Printer<uint32_t>::stream(s, indent + "  ", v.frame_number);
    s << indent << "objects[]" << std::endl;
    for (size_t i = 0; i < v.objects.size(); ++i)
    {
      s << indent << "  objects[" << i << "]: ";
      s << std::endl;
      s << indent;
      Printer< ::ld_msgs::ld_object_<ContainerAllocator> >::stream(s, indent + "    ", v.objects[i]);
    }
  }
};

} // namespace message_operations
} // namespace ros

#endif // LD_MSGS_MESSAGE_LD_OBJECT_LIST_H
